<?php
header("Content-Type: application/xml; charset=UTF-8");

## Configuration

include 'rss_config.php';


## RSS Description

echo '<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0">
<channel>
<title>'.$rss_title.'</title>
<link>'.$rss_link.'</link>
<description>'.$rss_description.'</description>
<language>'.$rss_language.'</language>';

## Get Hosts in Down and Recovery state if enabled

if ($c2r_showdown){

	$hdownsql = "SELECT * FROM host WHERE status < 3 AND disabled = ''";
	$hdownres = mysql_query($hdownsql) OR die(mysql_error());

	while ($hdown = mysql_fetch_object($hdownres)){

		if ($hdown->status == '2'){
			$status='Online again! Last Error: ';
			$statusdate=$hdown->status_rec_date;
		}else{
			$status='Offline! Last Error: ';
			$statusdate=$hdown->status_fail_date;
		}

		if (!$c2r_showip){
			$title=$hdown->description;
		}else{
			$title=$hdown->description.' - '.$hdown->hostname;
		}

		if ($c2r_shorturl){
			$link = $c2r_cactiurl.'/0-'.$hdown->status;
		} else {
			$link = $c2r_cactiurl.'/host.php?host_status='.$hdown->status;
		}

## Build RSS Feed Item

        	echo '<item>
	        <guid>'.time().'</guid>
        	<pubDate>'.date('r', strtotime($statusdate)).'</pubDate>
	        <title>'.$title.'</title>
        	<link>'.htmlspecialchars($link, ENT_QUOTES, 'UTF-8').'</link>
	        <description>
        	<![CDATA['.$hdown->description.' '.$status.$hdown->status_last_error.']]></description>
	        </item>';
	}
}

## Get Treshold Log if activated

if ($c2r_showthlog){
	$abfrage = "SELECT host.hostname, host.description AS hdescri, plugin_thold_log.* FROM plugin_thold_log LEFT JOIN host on host.id =plugin_thold_log.host_id";
	$ergebnis = mysql_query($abfrage) OR die(mysql_error());
	while($row = mysql_fetch_object($ergebnis)){

	        if (!$c2r_showip){
        	        $title=$row->hdescri;
	        }else{
        	        $title=$row->hdescri.' - '.$row->hostname;
	        }

                if ($c2r_shorturl){
	                $link = $c2r_cactiurl.'/'.$row->threshold_id.'-'.$row->host_id;

                } else {
                        $link = $c2r_cactiurl.'/plugins/thold/thold_graph.php?tab=log&status=-1&threshold_id='.$row->treshold_id.'&host_id='.$row->host_id.'&rows=30&filter=';
                }

## Build RSS Feed item 

		echo '<item>
		<guid>'.$row->id.'</guid>
		<pubDate>'.date('r', $row->time).'</pubDate>
		<title>'.$title.'</title>
		<link>'.htmlspecialchars($link, ENT_QUOTES, 'UTF-8').'</link>
		<description>
		<![CDATA['.$row->description.']]></description>
		</item>';
	}
}
echo '</channel></rss>';
mysql_close();
?>
